package MobileMonitoring;

import java.io.*;
import java.lang.*;
import java.util.*;
import java.net.*;
import SOMA.naming.*;
import com.adventnet.snmp.snmp2.*;

public class ConfigurationV3MA extends SnmpMobileManager
{
    //file di serializzazione della USMUserTable
    File serFile;
    //informazioni di sicurezza con cui il manager mobile Snmp
    //dovra' presentarsi agli agenti Snmp presenti sui vari place
    infoUser[] info_to_store;

    /**qui si recuperano le singole informazioni a partire dall'oggetto passato
    //in input e si inizializzano gli altri attributi.
    //o e' un oggetto della classe InfoConfiguration
    */
    public void putArgument(Object o)
    {
        InfoConfiguration Info = (InfoConfiguration) o;
        super.putArgument(Info);
        serFile = Info.getFile();
        info_to_store = Info.getSecInfo();
    }

    public void run()
    {
        super.run();
    }


    /**metodo di passaggio ad una tappa successiva,  qui che si controlla se il viaggio
    // finito, in tal caso si torna al Place di partenza
    */
    public void goNext()
    {
        super.goNext();
    }

    public void prepareLocalJob()
    {
    	api = new SnmpAPI();
    	api.start();
    	doLocalJob();
    }

    //metodo per la configurazione USM
    public void doLocalJob()
    {
        PrintStream out = agentSystem.getOut();
        String location = agentSystem.getPlaceID().toString();

        if (!(location.equals(targets[current].toString())))
        {
            trace_err(out,getHeader()+" Wrong Target. Right is: "+targets[current]);
            result_code[current] = false;
            if (++current != Ntargets)
	            nexthop = targets[current];
            api.close();
            goNext();
        }
        else
        {
        	//recupero la porta presso cui e' in ascolto l'agente
            int agentPort = snmpPorts[current];
            //dal momento in cui mi trovo sul place stesso dell'agente
            //l'indirizzo e' il localhost
            String agentAddr = "127.0.0.1";
		    //estraggo le informazioni da utilizzare sul nodo corrente dal vettore
        	infoUser currentInfoUSM = info_to_store[current];

        	//creo un'entry per la tabella dei motori Snmp per quello presente sul nodo corrente
        	SnmpEngineEntry snmpEntry = new SnmpEngineEntry(agentAddr,agentPort);


        	byte[] engineID = currentInfoUSM.getEngine();
        	snmpEntry.setEngineID(engineID);
        	SnmpEngineTable engineTable = api.getSnmpEngine();
            //aggiungo alla tabella dei motori un'entry completa di Ip,Porta,Nome
        	engineTable.addEntry(snmpEntry);

        	USMUserTable userTable = api.getUSMTable();
        	byte[] user = currentInfoUSM.getPrincipal();

        	int authp = currentInfoUSM.getAuthProtocol();
        	int privp = currentInfoUSM.getPrivProtocol();
        	if (authp != -1)
        		if (privp != -1) //caso in cui ho sia auth che priv
        		{
        			String authpw = new String(currentInfoUSM.getAuthPwd());
        			String privpw = new String(currentInfoUSM.getPrivPwd());
   			    	SnmpSession session = new SnmpSession(api);
   			    	try {session.open();}
   			    	catch(SnmpException e) {e.printStackTrace();}
			    	session.setVersion(SnmpAPI.SNMP_VERSION_3);
        			USMUtils.init_v3_params(new String(user),authp,authpw,privpw,agentAddr,agentPort,session);
        			session.close();
        		}
        		else //caso di sola auth
        		{
		   			byte[] authpw = currentInfoUSM.getAuthPwd();
			      	//creo un entry per la tabella degli utenti a partire dal nome del principal
        			//e da quello del motore locale
	         		USMUserEntry entry = new USMUserEntry(user,engineID);
   	        		entry.setAuthProtocol(authp);
        		    entry.setAuthPassword(authpw);
        			byte[] authKey = USMUtils.password_to_key(authp,authpw,authpw.length,engineID);
        			entry.setAuthKey(authKey);
        			entry.setSecurityLevel(Snmp3Message.AUTH_NO_PRIV);
        			userTable.addEntry(entry);
        		}
        	else //ne' auth ne' priv
        	{
        		USMUserEntry entry = new USMUserEntry(user,engineID);
       			entry.setSecurityLevel(Snmp3Message.NO_AUTH_NO_PRIV);
        		userTable.addEntry(entry);
        	}
       		//trasferisco su file le informazioni di configurazione cosi' che rimangano
        	//per la prossima volta che visitero' questo nodo
        	api.setSerializeFileName(serFile.getAbsolutePath());
        	try
        	{
           		result_code[current] = api.serialize();
            }
        	catch (SnmpException se)
        	{
        		trace_err(out,getHeader()+" Error during serialization");
        		result_code[current] = false;
        		if (++current != Ntargets)
	                nexthop = targets[current];
                api.close();
                goNext();
        	}

        	api.close();
       		if (++current != Ntargets)
	        	nexthop = targets[current];
            goNext();
   		}
   	}


}


