package MobileMonitoring;

import SOMA.naming.*;
import java.io.Serializable;

//classe contenente le informazioni di base che un qualunque agente mobile in qualita'
//di manager Snmp deve conoscere
public class DrivePlan extends BasicTour implements Serializable
{
    //snmpPorts sono le porte sulle quali si trovano in ascolto gli agenti Snmp dei
    //vari places da visitare
    int snmpPorts[] = null;
    //versions e' la lista delle versioni Snmp supportate dai vari agenti Snmp
    int versions[] = null;

    public DrivePlan(AgentID master,PlaceID[] dest,int[] ports,int[] snmpV,boolean deb)
    {
    	super(master,dest,deb);
        snmpPorts = ports;
        versions = snmpV;
    }

    //restituisce la lista delle porte su cui si trovano in ascolto gli agenti Snmp
    //nello stesso ordine in cui verrano visitati
    public int[] getPorts()
    {
        return snmpPorts;
    }

    //restituisce la lista delle versioni Snmp supportate dai vari agenti Snmp
    //nello stesso ordine in cui verrano visitati
    public int[] getVersions()
    {
        return versions;
    }

    //restituisce tutte le informazioni associate ad una tappa: nome del Place,
    //porta d'ascolto, versione Snmp
    //index e' il numero d'ordine della tappa (0 la prima, 1 la seconda ..)
    //place e' il nome del Place su cui fare tappa
    //port e' la porta cui rivolgersi durante la tappa
    //snmpV e' la versione di Snmp da utilizzare per rivolgersi all'agente Snmp
    public void getAll(int index,PlaceID place,int port,int snmpV)
    {
        place = steps[index];
        port = snmpPorts[index];
        snmpV = versions[index];
    }
    
        
}