package MobileMonitoring;

import SOMA.naming.*;
import java.io.Serializable;

/**classe contenente le informazioni necessarie ad un agente mobile, nel ruolo di
//StaticManager, per effettuare richieste Snmp atomiche (get/getnext/getbulk) basandosi
//eventualmente (v3) sulla configurazione del motore.
*/
public class InfoAtomicSnmpOp extends InfoBasedOnConfig implements Serializable
{
    //OIDs e' la lista degli object identifier associati alle variabili Snmp d'interesse
    String[] OIDs = null;
    //tipo dell'operazione coinvolta cosi' come definita in SnmpAPI
    byte op_type;
    String[] argsop = null;

    /**costruttore
    //reqIDs e' la lista degli object identifier associati alle variabili Snmp d'interesse
    //op e' il tipo di operazione richiesta, puo' assmere i valori SnmpAPI.GET/GENEXT/GETBULK
    //extra e' una lista di eventuali argomenti aggiuntivi richiesti da una particolare operazione:
    //per ora puo' solo contenere non_repetitions e max_repetitions in caso di GetBulk
    //e' null se non ne sono previsti
    */
    public InfoAtomicSnmpOp(AgentID master,PlaceID[] places, int[] ports, int[] vs, String[] names,String file, String[] reqIDs, byte op,String[] extra,boolean deb)
    {
        super(master,places,ports,vs,names,file,deb);
        OIDs = reqIDs;
        op_type = op;
        argsop = extra;
    }

    //restituisce la lista degli object identifier da richiedere ad ogni agente Snmp visitato
    public String[] getIDs()
    {
        return OIDs;
    }

    //restituisce il tipo di operazione Snmp da eseguire
    public byte getOp()
    {
        return op_type;
    }

    //restituisce il numero di object identifier richiesti
    public int getNReq()
    {
        return OIDs.length;
    }

    //restituisce la lista di argomenti eventualmente richiesti dalla particolare operazione
    public String[] getExtra()
    {
        return argsop;
    }

}