package MobileMonitoring;

import SOMA.naming.*;
import java.util.StringTokenizer;
import java.util.NoSuchElementException;
import java.io.Serializable;

/**classe contenente tutte le informazioni necessarie ad un agente mobile, nel ruolo di manager Snmp,
//per effettuare il filtraggio di una tabella in base ad una condizione
*/
public class InfoFiltering extends InfoTable implements Serializable
{
    String OIDcol = null;
    String rif_inf = null;
    String rif_sup = null;
    String cond_inf = null;
    String cond_sup = null;

    /**OIDcol e' l'object identifier della colonna che deve essere soggetta a verifica di condizione
    //cond e' la condizione che puo' assumere una delle forme:
    //val1 <= OIDcol <= val2 oppure OIDcol <= val2 oppure OIcol >= val1 avendo anche la possibilita'
    //di specificare estremi inclusi/esclusi
    */
    public InfoFiltering(AgentID master,PlaceID[] places, int[] ports, int[] vs, String[] names, String file, String OIDtab, String[] OIDcols, String cond,boolean deb)
    {
        super(master,places,ports,vs,names,file,OIDtab,OIDcols,deb);
        StringTokenizer st = new StringTokenizer(cond);
        if (st.countTokens() == 3)
        {
            String condition = null;
            try
            {
                OIDcol = st.nextToken();
                condition = st.nextToken();
            }
            catch (NoSuchElementException e) {}

            if (condition.startsWith(">"))
            {
                rif_inf = "ANY";
                cond_sup = condition;
            }
            else
            {
                rif_sup = "ANY";
                cond_inf = condition;
            }
        }
        else //5
        try
        {
            rif_inf = st.nextToken();
            cond_inf = st.nextToken();
            OIDcol = st.nextToken();
            cond_sup = st.nextToken();
            rif_sup = st.nextToken();
        }
        catch (NoSuchElementException e) {}
    }

    //verifica se si tratta di una condizione a range (valore della colonna compreso tra
    //due valori) oppure semplice (valore della colonna <,>,<=,>= di un certo valore)
    public boolean isRange()
    {
        return ((rif_inf != "ANY") && (rif_sup != "ANY"));
    }

    public String getInfVal()
    {
        return rif_inf;
    }

    public String getSupVal()
    {
        return rif_sup;
    }

    public String getOIDRif()
    {
        return OIDcol;
    }

    public String getInfCond()
    {
        return cond_inf;
    }

    public String getSupCond()
    {
        return cond_sup;
    }

    public void getVals(String inf, String sup)
    {
        inf = rif_inf;
        sup = rif_sup;
        return;
    }

    public void getConds(String inf, String sup)
    {
        inf = cond_inf;
        sup = cond_sup;
        return;
    }

}