package MobileMonitoring;

import SOMA.naming.*;

/**classe contenente le informazioni necessarie ad un agente mobile, nel ruolo di manager Snmp,
// per il reperimento di una tabella
*/
public class InfoTable extends InfoBasedOnConfig
{
    //OIDTable e' l'object identifier della tabella sotto forma di stringa
    String OIDTable = null;
    //OIDcolumns e' la lista degli object identifier associati alle varie colonne della
    //tabella, privati del prefisso comune per limitare il peso dell'agente mobile
    //es. .1.3.6.1.2.1.2.2.1.1 --> 1.1
    String[] OIDcolumns = null;
    int Ncol = 0;

    //OIDtab e' l'object identifier della tabella oggetto della richiesta
    //OIDcols e' la lista degli object identifier associati alle colonne della tabella
    //e privati del prefisso comune
    public InfoTable(AgentID master,PlaceID[] places, int[] ports, int[] vs, String[] names, String file, String OIDtab, String[] OIDcols,boolean deb)
    {
        super(master,places,ports,vs,names,file,deb);
        OIDTable = OIDtab;
        OIDcolumns = OIDcols;
        Ncol = OIDcols.length;
    }

    //restitisce l' object identifier della tabella
    public String getTab()
    {
        return OIDTable;
    }

    //restituisce la lista degli object identifier completi delle colonne della tabella
    //es. oidtab = .1.3.6.1.2.1.2.2    oidcol = 1.1 
    public String[] getCols()
    {
        return OIDcolumns;
    }

	public String[] getTotalCols()
	{
        String[] ret = new String[Ncol];
        for (int j=0; j< Ncol; j++)
            ret[j] = OIDTable+"."+OIDcolumns[j];
        
        return ret;
    }
    
    public int getNCol()
    {
        return Ncol;
    }
}