package MobileMonitoring;

import StaticMonitoring.Settings;
import SOMA.agent.*;
import SOMA.naming.*;
import SOMA.utility.*;
import com.adventnet.snmp.snmp2.*;
import java.io.*;
import java.util.*;
import java.net.*;

public class PollerHFMA extends HealthMA
{

	//intervallo di osservazione
	//rimane a 0 quando si vuole controllare da remoto la terminazione
	//(N.B. in questo caso deve essere creato come traceable)
	int observation = 0;
	//intervallo di polling
	int pollint = 0;
	//numero di ripetizione da effettuare: verra' utilizzato solo se si ha un intervallo di osservazione
	//predeterminato
	int nvolte = 0;
	transient Alarm timer = null;
	//questa var mi serve a sapere se l'Alarm e' stato fermato o si e' fermato 
	//perche' e' finito il pollint
	transient boolean expired = true;
	//visto che dovro' interagire con un solo nodo introduco come variabile di classe
	//la sessione che utilizzero', anche perche' sia visibile all'interno del metodo di gestione
	//dell'evento
	transient SnmpSession session = null;
	transient Settings sets = null;
	//vettore in cui memorizzare tutti i risultati: ogni elemento rappresentera' 
	//un campione di polling: un Object, in caso di HF semp;ice; una Hashtable, in caso di HF su tabella
	Vector job_result = null;
	

	public void putArgument(Object o)
	{
		InfoPolling Info = (InfoPolling)o;
		observation = Info.HowLong();
		pollint = Info.HowOften();
		nvolte = (observation/pollint);
		InfoHF subInfo = (InfoHF)Info.getInfo();
		super.putArgument(subInfo);
		job_result = new Vector();
	}
	
    //qui sono racchiuse le operazioni necessarie all'adempimento del compito
    //specifico di questo Agente Mobile
    public void doLocalJob(Settings sets,SnmpSession session)
    {
        PrintStream out = agentSystem.getOut();
        if (rowID != null)
        	job_result.add(current,snmpTableHF(sets,session));
        else
        	job_result.add(current,snmpHF(sets,session));

        result_code[current] = true;
        session.close();
        api.close();
        if (++current != Ntargets)
        	nexthop = targets[current];
        goNext();
    }

	void poll()						
	{
		new Thread(){
		public void run(){
		if (expired) //e' stato fermato
		{
			session.close();
			api.close();
			goHome();
		}
		else  //e' scaduto il pollint
		{
        	if (rowID != null)
        		job_result.add(current,snmpTableHF(sets,session));
       		else
        		job_result.add(current,snmpHF(sets,session));

		}	}
		}.start();
		
	}

}