package MobileMonitoring;

import SOMA.*;
import SOMA.agent.*;
import SOMA.naming.*;
import SOMA.naming.place.*;
import java.util.*;
import java.io.*;

public class subManager extends Agent 
{
	PlaceID home;
	//identificatore dell'agente che delega
	AgentID supervisor;
	//dominio di destinazione
	PlaceID domain;
	PlaceID[] places;
	transient Environment env;
	//coda di richieste non ancora processate (Vector --> FIFO)
	transient Vector queue;
	
	public void putArgument(Object o)
	{
		subInfo sub = (subInfo) o;
		supervisor = sub.master;
		domain = sub.target;
	}
	
	public void run()
	{
		home = agentSystem.getPlaceID();
		try { go(domain,"doLocalJob"); }
		catch (Exception e) { e.printStackTrace(); }
		//inizializza la coda delle richieste sospese
		queue = new Vector();
		env = agentSystem.getEnvironment();
		places = env.placeNameService.getPlacesArray();
		doLocalJob();
	}
	
	public void doLocalJob()
	{
		PrintStream out = agentSystem.getOut();
		Message request;
		for (;;)
		{
			//prima guarda nella coda se ci sono richieste pendenti
			if (queue.size() != 0)
				request = (Message)queue.remove(0);
			else //altrimenti si pone in attesa sulla mailbox
				request = mailbox.getMessage();
			
			Request req = (Request) request.message;
			//se quello ricevuto e' il messaggio di stop da parte del supervisor termina
			if (req.agentName.equals("STOP"))
				return;
			else    //richiesta di operazione di monitoraggio
			//N.B. qui potrei anche creare un nuovo thread che si occupa di servire la richiesta mentre
			//quello principale continua nel ciclo di accettazione
			{
				//inserisce nel campo delegator, dell'Info da passare all'agente che crea, il proprio 
				//identificatore cosi' che possa restituirgli la risposta
				req.agentInfo.delegator = getID();
				//inserisce anche i nomi dei place del dominio da visitare
				req.agentInfo.steps = places;
				AgentWorker worker = env.agentManager.createAgent(req.agentName,req.agentInfo,false,true);
				if (worker == null)
				{
					Message notify = new Message(new String("ERROR"),getID(),supervisor);
					agentSystem.sendMessage(notify);
				}
				else
				{
					try { worker.start(); }
					catch (Exception e) { e.printStackTrace(); 
										Message notify = new Message(new String("ERROR"),getID(),supervisor);
										agentSystem.sendMessage(notify); }
					//dopo aver creato l'agente si pone in attesa della risposta
										
					Message answer = mailbox.getMessage();
					while ( answer.from != worker.agent.getID() )
					{
						//se non si tratta della risposta proveniente dall'agente creato precedentem.
						//si accoda, perche' e' una richiesta
						queue.addElement(answer);
						answer = mailbox.getMessage();
					}
				
					agentSystem.sendMessage(new Message(answer.message,getID(),supervisor));
				}
			}				
		}	
	}	
				
}			
			
			
			
			