package StaticMonitoring;

import MonitorConfig.snmpTable;
import com.adventnet.snmp.snmp2.*;
import java.io.PrintStream;

class ReceiverFilterReq extends ReceiverTableReq
{
	String rif_inf;
	String cond_inf;
	String oid_col;
	String cond_sup;
	String rif_sup;
	int Ncol;

	protected ReceiverFilterReq(StaticManager man,snmpTable t,int firstID,String rif1,String cond1,String oid_col,String cond2,String rif2,boolean deb,PrintStream o)
	{
		super(man,t,firstID,deb,o);
	    //risalgo al numero di colonna costruendo la stringa che rimane se si toglie all'oid della colonna
        //quello della tabella ed il "." es "1.2.3.1" - "1.2.3." --> "1"
        int index = oid_col.lastIndexOf('.');
        String numcol = oid_col.substring(++index);
        Ncol = Integer.parseInt(numcol);
        rif_inf = rif1;
        rif_sup = rif2;
        cond_inf = cond1;
        cond_sup = cond2;
    }

    public boolean callback(SnmpSession session, SnmpPDU pdu, int requestID)
    {
    	String[] OIDs = new String[ncol];
    	if (outstandID != requestID)
    	{
    		trace_err("Answer received not excpected");
    		return false;
    	}

		//se tutto ok avvio la richiesta di un'altra riga e aggiungo quella ricevuta alla tabella
		boolean next = manager.check(pdu,oid_tab);
        if (next)
        {
      	    if (manager.verifyRange(pdu.getVariable(Ncol-1),rif_inf,cond_inf,cond_sup,rif_sup))
            {
                table.addRow(pdu);
                nrow++;
            }

	        for(int i=0; i<ncol; i++)
	            OIDs[i] = pdu.getObjectID(i).toString();
	        //N.B anche la richiesta successiva e' asincrona quindi c'e'
	        //un ritorno immediato
	        int req = 0; //lascio che sia il sistema ad assegnare l'identificatore
	        //l'invocazione di snmpAsyncOp avviene passando settaggi nulli perche' sono stati gia' fatti
	        //nella prima richiesta
	        recentPDU = manager.snmpAsyncOp(sets,session,OIDs,GETNEXT,null,req);
	        recentID = recentPDU.getReqid();
	        //aggiungo l'identificatore della richiesta appena inviata alla lista
	        //di quelle in sospeso
	        outstandID = recentID;
       	}
	    else //errore o risposta non piu' relativa alla tabella
            done = true;

       	return next;
     }


 }